<template>
  <div id="preview-div">
    <div :key="line.index" v-for="line in docContentLines">
      <p :style="applyStyles(line)">{{line.text}}</p>
    </div>
  </div>
</template>

<script>
import EventBus from "./../eventbus";
//import extendedH1 from "./ExtendedComponents/h1";

export default {
  components: {
    //xH1: extendedH1
  },

  data() {
    return {
      docContentLines: []
    };
  },
  methods: {
    applyStyles(lineObj) {
      return {
        "text-align":
          !lineObj.align || lineObj.align === "default"
            ? "left"
            : lineObj.align,
        color:
          !lineObj.color || lineObj.color === "default"
            ? "black"
            : lineObj.color,
        "font-weight":
          !lineObj.fw || lineObj.fw === "default" ? "normal" : lineObj.fw.trim(),
        "font-size":
          !lineObj.fs || lineObj.fs === "default" ? "14px" : lineObj.fs.trim() + "px"
      };
    }
  },
  created() {
    EventBus.$on("updatePreview", data => {
      let dLines = data.split("\n");
      this.docContentLines = [];
      dLines.map((line, index) => {
        let lineObj = {};
        let lineProps = line.split("#");
        if (lineProps.length > 1) {
          lineObj["lineIndex"] = index;
          //lineObj['elemType'] = lineProps[0];
          lineObj["align"] = lineProps[0];
          lineObj["color"] = lineProps[1];
          lineObj["fw"] = lineProps[2];
          lineObj["fs"] = lineProps[3];
          lineObj["text"] = lineProps[4];
        }
        else{
          lineObj["text"] = lineProps[0];
        }
        this.docContentLines.push(lineObj);
        this.$emit('updateStatus', 'Completed');
      });
    });
  }
};
</script>

<style scoped>
#preview-div {
  border: 1px solid lightgray;
  height: 100%;
  width: 49%;
  float: right;
  padding: 15px;
  box-sizing: border-box;
}
</style>